﻿using System;
using System.Collections.Generic;
using Sce.PlayStation.Core;
using Sce.PlayStation.Core.Imaging;
using Sce.PlayStation.Core.Environment;
using Sce.PlayStation.HighLevel.UI;

namespace ACW_08241
{
    public partial class HighScore
    {
		Label messageField;
		Button saveButton;

        private void InitializeWidget()
        {
            InitializeWidget(LayoutOrientation.Horizontal);
        }

        private void InitializeWidget(LayoutOrientation orientation)
        {
			messageField = new Label();
			messageField.Name = "messageField";
			messageField.TextColor = new UIColor(255f / 255f, 255f / 255f, 255f / 255f, 255f / 255f);
            messageField.Font = new UIFont(FontAlias.System, 25, FontStyle.Regular);
			messageField.Text = "New high score!  Enter your name";
            this.RootWidget.AddChildLast(messageField);
		
			saveButton = new Button();
			saveButton.Name = "enterButton";
			saveButton.Text = "Save";
			this.RootWidget.AddChildLast(saveButton);

            SetWidgetLayout(orientation);
            UpdateLanguage();
        }
		
		public void SetVisibility(bool visible)
		{
			messageField.Visible = visible;
			saveButton.Visible = visible;
		}
		
        private LayoutOrientation _currentLayoutOrientation;
        private void SetWidgetLayout(LayoutOrientation orientation)
        {
            switch (orientation)
            {
                case LayoutOrientation.Vertical:
                    this.DesignWidth = 480;
                    this.DesignHeight = 854;

                    break;

                default:
                    this.DesignWidth = 854;
                    this.DesignHeight = 480;

                    messageField.SetPosition(100, 100);
                    messageField.SetSize(DesignWidth-200, 34);
                    messageField.Anchors = Anchors.None;
					messageField.HorizontalAlignment = HorizontalAlignment.Center;

                    saveButton.SetPosition(350, 280);
                    saveButton.SetSize(DesignWidth-700, 34);
                    saveButton.Anchors = Anchors.None;
					saveButton.HorizontalAlignment = HorizontalAlignment.Center;
					saveButton.ButtonAction += new EventHandler<TouchEventArgs>(saveButton_ButtonAction);

                    break;
            }
            _currentLayoutOrientation = orientation;
        }
		
		void saveButton_ButtonAction(object sender, TouchEventArgs e)
        {
			SaveScores();
		}
		
        private void UpdateLanguage()
        {
        }

        private void onShowing(object sender, EventArgs e)
        {
            switch (_currentLayoutOrientation)
            {
                case LayoutOrientation.Vertical:
                    break;

                default:
                    break;
            }
        }

        private void onShown(object sender, EventArgs e)
        {
            switch (_currentLayoutOrientation)
            {
                case LayoutOrientation.Vertical:
                    break;

                default:
                    break;
            }
        }

    }
}
