using System;
using System.Net.Sockets;
using System.Net;

using Sce.PlayStation.HighLevel.UI;
using BrickSmashDemo;

namespace ACW_08241
{
	public partial class HighScore : Scene
	{		
		private bool saved = false;
		static TcpClient client = new TcpClient();
		
//		public struct LeaderboardStruct
//        {
//            public string name;
//            public int score;
//        }
//
//        public static LeaderboardStruct[] leaderboard = new LeaderboardStruct[NUM_OF_SCORES];
		
		private WhoIsRead toServer = new WhoIsRead(client);
		
		public LeaderboardItem[] leaderboard;
			
		public HighScore (ref LeaderboardItem[] inleaderboard)
		{
			InitializeWidget();

			SetVisibility(false);

			UISystem.SetScene(this);
			
			leaderboard = inleaderboard;

			// get the saved high scores if they exist...
			if(!GetScores(client, ref leaderboard))
				Init(ref leaderboard); 	// ...create scores if they do not exist
		}
		
		// Get the saved high scores from the server
		public bool GetScores(TcpClient client, ref LeaderboardItem[] leaderboard)
		{
			//Set up a try/catch.
			//If the data sends and recieves -Return True and write it to the text file
			//else
			//It returns false (catched)
			
			try
			{
				toServer.GetData(ref leaderboard);
				return true;
			}
			catch
			{
				return false;
			}
			
		}
		
		// Let the BrickSmashProgram know if we have saved the new highscores to the server
		public bool HasSavedNewHighScore()
		{
			return saved;
		}
		
		// Send the highscores to the server
		private void SaveScores()
		{
			try
			{
				toServer.SendLeaderboard(ref leaderboard);
				//SaveLocal(ref leaderboard);
				saved = true;
			}
			catch
			{
				saved = false;
			}
				// assumes that the highscores have been successfully sent to the server
			SetVisibility(false);
			
			//Save to server
			//Save locally
		}
		
		// Allow BrickSmashProgram to enter of a new highscore
		public void EnterNewScore(int score, ref LeaderboardItem[] leaderboard)
		{
			for (int i = 0; i < 5; i++) 
			{
				if (score >= leaderboard[i].SCORE) 
				{
					for (int j = leaderboard.Length - 1; j > i; j--)
					{
						leaderboard[j].NAME = leaderboard[j - 1].NAME;
						leaderboard[j].SCORE = leaderboard[j - 1].SCORE;
					}
					leaderboard[i].SCORE = score;
					leaderboard[i].NAME = "player";
					try
					{
						toServer.SendOneScore(leaderboard[i].NAME, leaderboard[i].SCORE);
					}
					catch
					{
						break;
					}
					break;
				}
			}
			
			SetVisibility(true);
			
			
			saved = true;
		}
		
		// Allow BrickSmashProgram to test if the new score is a new highscore
		public bool IsNewHighScore(int score, ref LeaderboardItem[] leaderboard)
		{
			for (int i = 0; i < 5; i++) 
			{
				if (score >= leaderboard[i].SCORE) 
				{
					EnterNewScore(score, ref leaderboard);
					//saved = true;
					return true;
				}
			}
			saved = false;
			return false;
		}
		
		// Initialise names and scores if they do not exist on the server
		private void Init(ref LeaderboardItem[] leaderboard)
		{
			leaderboard[0] = new LeaderboardItem("Adam", 2100);
			leaderboard[1] = new LeaderboardItem("Adam", 900);
			leaderboard[2] = new LeaderboardItem("Adam", 800);
			leaderboard[3] = new LeaderboardItem("Adam", 500);
			leaderboard[4] = new LeaderboardItem("Adam", 300);
		}
	}
}

