using System;
using System.Net.Sockets;
using System.Net;
using System.IO;
using BrickSmashDemo;
using ACW_08241;

namespace BrickSmashDemo
{
	public class WhoIsRead
	{
		//TcpClient client; 
		
		
		StreamWriter sw;
		StreamReader sr;
		
		public WhoIsRead (TcpClient client)
		{
			//Reading from the WHOIS server
			sw = new StreamWriter(client.GetStream());
			sr = new StreamReader(client.GetStream());
			//leaderboard = inLeaderboard;
			client.Connect(IPAddress.Loopback, 43);
			
		}
		/// <summary>
		/// Gets the leaderbaord data from the server
		/// </summary>
		/// <param name='leaderboard'>
		/// Leaderboard.
		/// </param>
		public void GetData(ref LeaderboardItem[] leaderboard)
		{
			sw.WriteLine("REQUEST");
			sw.Flush();
			
			string inputStreamString = sr.ReadLine();
			char[] deliminators = new char[1];
            deliminators[0] = ' ';
            string[] splitString = inputStreamString.Split(deliminators);
			
			leaderboard[0].NAME = splitString[0]; leaderboard[0].SCORE = int.Parse(splitString[1]);
            leaderboard[1].NAME = splitString[2]; leaderboard[1].SCORE = int.Parse(splitString[3]);
            leaderboard[2].NAME = splitString[4]; leaderboard[2].SCORE = int.Parse(splitString[5]);
            leaderboard[3].NAME = splitString[6]; leaderboard[3].SCORE = int.Parse(splitString[7]);
            leaderboard[4].NAME = splitString[8]; leaderboard[4].SCORE = int.Parse(splitString[9]);
			
		}
		
		/// <summary>
		/// Only send one score to update the server list
		/// </summary>
		/// <param name='leaderboard'>
		/// Leaderboard.
		/// </param>
		/// <param name='score'>
		/// Score.
		/// </param>
		/// <param name='i'>
		/// Number in the array of scores to update
		/// </param>
		public void SendOneScore(string name, int score)
		{
			sw.WriteLine(name + " " + score);
			sw.Flush();
		}
		
		/// <summary>
		/// Sends the entire leaderboard
		/// </summary>
		/// <param name='leaderboard'>
		/// Leaderboard.
		/// </param>
		public void SendLeaderboard(ref LeaderboardItem[] leaderboard)
		{
			sw.WriteLine(leaderboard[0].NAME + " " + leaderboard[0].SCORE + " " + 
			             leaderboard[1].NAME + " " + leaderboard[1].SCORE + " " + 
			             leaderboard[2].NAME + " " + leaderboard[2].SCORE + " " + 
			             leaderboard[3].NAME + " " + leaderboard[3].SCORE + " " + 
			             leaderboard[4].NAME + " " + leaderboard[4].SCORE);
			sw.Flush();
		}
	}
}

